void serialEvent(Serial myPort) 
{
  previnByte = inByte;
  inByte = myPort.read();

  println("Received: "+inByte+"  Char: "+char(inByte));

  if (SentCmdRequest == true && previnByte == 'a' && inByte == '9')
  {
    SentCmdRequest = false;
    RecievedOpenAck = true;
    //myPort.write("nled99"); 
    myPort.write("n"); 
    myPort.write("l");  
    myPort.write("e");   
    myPort.write("d");  
    myPort.write("9");   
    myPort.write("9");

    println("Sent Acknowledge");
  } else if (RecievedOpenAck == true  && previnByte == 'f' && inByte == '0')
  {
    println("Cmd Acknowledged, Sending - CmdByte: "+cmdByte+" : "+cmdData[0]+" : "+cmdData[1]+" : "+cmdData[2]+" : "+cmdData[3]);
    RecievedOpenAck = false;
    myPort.write(cmdByte);
    myPort.write(cmdData[0]);  
    myPort.write(cmdData[1]);   
    myPort.write(cmdData[2]);  
    myPort.write(cmdData[3]); 

    switch(cmdByte)
    {
    case 1:  //Upload Configurations
      SendConfigurations();  
      break;
    case 4: //Open Connection
      SentOpenRequest = true;
      break;
    }  //end switch
  } else if (SentOpenRequest == true)
  {
    println("Counter: "+ReceiveCounter);
    switch(ReceiveCounter)
    {
    case 0:
      HardwareID = inByte;
      break;      
    case 1:
      HardwareVersion = inByte;
      break;
    case 2:
      FirmwareVersion = inByte;
      break;
    case 3:
      FirmwareRevision = inByte;
      SentOpenRequest = false;

      hardwareVersionLabel.setText(""+HardwareVersion);
      firmwareVersionLabel.setText(""+FirmwareVersion+cRevLetters[FirmwareRevision]);

      int holdmainDeviceDropList = mainDeviceDropList.getSelectedIndex();

      //sets the string device name and setup the windows
      switch(HardwareID)
      {
      case 30:
        hardwareNameLabel.setText(cControllerID30);
        mainDeviceDropList.setSelected(5);
        break;
      case 104:
        hardwareNameLabel.setText(cControllerID104);
        mainDeviceDropList.setSelected(6);        
        break;      
      case 148:
        hardwareNameLabel.setText(cControllerID148);
        mainDeviceDropList.setSelected(3);        
        break;       
      case 43:
        hardwareNameLabel.setText(cControllerID43);
        mainDeviceDropList.setSelected(7);        
        break;
      case 108:
        hardwareNameLabel.setText(cControllerID108);
        mainDeviceDropList.setSelected(4);        
        break;
      } //end HardwareID switch

      if (holdmainDeviceDropList != mainDeviceDropList.getSelectedIndex()) SelectDeviceWindow(mainDeviceDropList.getSelectedIndex());

      commandResultLabel.setText("Device ID Request Success");
      break;
    }  
    ReceiveCounter++;
  } else if (WaitingForConfigAck == true)
  {
    if (previnByte == 'C' && inByte == 'S')
    {
      commandResultLabel.setText("Configurations Upload Acknowledged");
      WaitingForConfigAck = false;
    }
  }
} //end func

//=====================================================================================================

void RequestCommand()
{
  try {
    // myPort.write("NLED11"); 
    myPort.write("N"); 
    myPort.write("L");  
    myPort.write("E");   
    myPort.write("D");  
    myPort.write("1");   
    myPort.write("1");
    SentCmdRequest = true; 
    RequestCmdTimeOut = 6;
  }
  catch(Exception e)
  {
    println("Port Not Open, Or Unable to Send"); 
    commandResultLabel.setText("Port Not Open, Or Unable to Send CMD"); 
    CloseCOMPort();
  }
} //end func()

//=====================================================================================================

void OpenConnection()
{
  println("OpenConnection() - Attempting Connection");
  commandResultLabel.setText("");

  cmdByte = 4; //open connection
  cmdData[0] = 0;
  cmdData[1] = 0; 
  cmdData[2] = 0;  
  cmdData[3] = 0;  

  ReceiveCounter = 0;
  RequestCommand();
}//end func()

//=====================================================================================================

void RequestConfigurationUpload()
{
  cmdByte = 1;
  cmdData[0] = 0;
  cmdData[1] = 0;  
  cmdData[2] = 0;
  cmdData[3] = 0;
  RequestCommand();
} //end func

//=====================================================================================================

void CloseCOMPort()
{
  println("CloseCOMPort() - Closing Port "+myPort);    
  try   
  {  
    //close COM port
    myPort.stop();
    myPort.dispose();
    commandResultLabel.setText("COM Port Closed"); 
    connectButton.setText("Connect to COM");
    connectButton.setLocalColorScheme(0); //RED_SCHEME
  }
  catch(Exception e)
  {
    println("No Port To Close");
    commandResultLabel.setText("No Port To Close");
  }
}

//=====================================================================================================

void ConnectToCOMPort()
{
  try {
    myPort.stop();
  }
  catch(Exception e) {
  }

  String portName = Serial.list()[COMPortDD.SelStr];
  println(portName);
  try {
    myPort = new Serial(this, portName, DeviceBaudRate);
    OpenedBaudRate = DeviceBaudRate;
    connectButton.setText("Connected");
    commandResultLabel.setText("Successfully connected to COM Port "+COMPortDD.SelStr);
    println("Successfully connected to COM Port "+COMPortDD.SelStr+" at "+DeviceBaudRate+" baud");
    connectButton.setLocalColorScheme(1); //GREEN_SCHEME
  }
  catch(Exception e)
  {
    connectButton.setText("Port Unable to Connect");
    println("Port Unable to Connect");
  }
}//end func

