//add functions from aurora, connect and request n such

void SelectDeviceWindow(int passedID)
{
  //opens the correct window for each device upon selection
  println("SelectDeviceWindow() with "+passedID);

  WindowMini.setVisible(false);  
  WindowIon.setVisible(false);  
  WindowOcto.setVisible(false);  
  Window4ChanDMX.setVisible(false); 
  Window16BitLamp.setVisible(false); 
  Window30Chan.setVisible(false);    
  WindowMiniPlus.setVisible(false);

  switch(passedID)
  {
  case 0:
    break;
  case 1:
    WindowMini.setVisible(true);    
    DeviceBaudRate = 9600;
    if (OpenedBaudRate != DeviceBaudRate)
    {
      CloseCOMPort();
      ConnectToCOMPort();
    }      
    break;
  case 2:
    WindowMiniPlus.setVisible(true); 
    DeviceBaudRate = 9600;
    if (OpenedBaudRate != DeviceBaudRate)
    {
      CloseCOMPort();
      ConnectToCOMPort();
    }    
    break;      
  case 3:
    WindowIon.setVisible(true);    
    break;
  case 4:
    WindowOcto.setVisible(true);  
    DeviceBaudRate = 19200;
    if (OpenedBaudRate != DeviceBaudRate)
    {
      CloseCOMPort();
      ConnectToCOMPort();
    }    
    break;
  case 5:
    Window30Chan.setVisible(true); 
    break;
  case 6:
    Window16BitLamp.setVisible(true);    
    break;    
  case 7:
    Window4ChanDMX.setVisible(true);  
    DeviceBaudRate = 19200;
    if (OpenedBaudRate != DeviceBaudRate)
    {
      CloseCOMPort();
      ConnectToCOMPort();
    }
    break;  
  case 8:

    break;
  }//end switch
}

//===========================================================================================

void ChangeMiniFirmwareVersion()
{
  //miniDropList1 and miniTextField2 get changed & label4

  if (miniDropList3.getSelectedIndex() == 2)
  {
    //firmware version 1
    label4.setText("DMX Pixel Amount(1-41)");
    miniTextField2.setText("41");  
    miniDropList1.setItems(loadStrings("list_minifwv1"), 0);
  } else if (miniDropList3.getSelectedIndex() == 1)
  {
    //firmware version 2
    label4.setText("DMX Pixel Amount(1-57)");
    miniTextField2.setText("57");   
    miniDropList1.setItems(loadStrings("list_minifwv2"), 0);
  } else
  {
    //firmware version 3
    label4.setText("DMX Pixel Amount(1-57)");
    miniTextField2.setText("57");
    miniDropList1.setItems(loadStrings("list_636068"), 0);
  }
} //end ChangeMiniFirmwareVersion()

//===========================================================================================

void SendConfigurations()
{
  println("SendConfigurations() with ID "+mainDeviceDropList.getSelectedIndex());  
  tempFlags = 0;
  temp2Flags = 0; 

  switch(mainDeviceDropList.getSelectedIndex())
  {
  case 0:
    break;
  case 1: //mini not sent from here
    //isn't sent from here, see uploadButton_click1()   
    break;
  case 2: //mini plus not sent from here
    //isn't sent from here, see uploadButton_click1()
    break;      
  case 3: //Ion
    ionSendConfigurations();
    break;
  case 4: //Octo
    //isn't sent from here, see uploadButton_click1()
    break;
  case 5: //30 Chan
    chan30SendConfigurations();
    break;
  case 6: //16bit rgbw
    rgbwSendConfigurations();
    break;    
  case 7: //4chan dmx
    dmxwashSendConfigurations();
    break;  
  case 8:

    break;
  } //end switch
  WaitingForConfigAck = true;
  commandResultLabel.setText("Configuration Data Sent");
} //end SendConfigurations()

